Imports Syncfusion.Windows.Forms.Grid

Public Class GridFavorisCellModel
  Inherits GridDropDownGridListControlCellModel

  Public Sub New(ByVal grid As GridModel)
    MyBase.New(grid)
  End Sub

  Public Overrides Function CreateRenderer(ByVal grdControl As Syncfusion.Windows.Forms.Grid.GridControlBase) As Syncfusion.Windows.Forms.Grid.GridCellRendererBase
    Return New GridFavorisCellRenderer(grdControl, Me)
  End Function
End Class

Public Class GridFavorisCellRenderer
  Inherits GridDropDownGridListControlCellRenderer

  Private Const COL_PROJET = 1
  Private Const COL_TACHE = 2
  Private Const COL_DESCRIPTION = 3
  Private Const COL_DESCRIPTION2 = 4

  Private _gridFavoris As GridControl

  Public Sub New(ByVal grid As GridControlBase, ByVal cellModel As GridCellModelBase)

    MyBase.New(grid, cellModel)

    Me.DisableTextBox = True

    DropDownButton = New GridCellComboBoxButton(Me)

    AddHandler grid.CurrentCellShowingDropDown, AddressOf gridFavoris_CurrentCellShowingDropDown
    AddHandler grid.CurrentCellActivated, AddressOf gridFavoris_CurrentCellActivated

    _gridFavoris = grid

  End Sub 'New

  Private Sub gridFavoris_CurrentCellActivated(ByVal sender As Object, ByVal e As System.EventArgs)
    Try
      Dim cc As GridCurrentCell = Grid.CurrentCell
      Dim cr As GridDropDownGridListControlCellRenderer = cc.Renderer
      Dim strIDProjet As String

      If cc.ColIndex = COL_TACHE Then
        Dim dv As New DataView(dtTaches)
        strIDProjet = _gridFavoris(cc.RowIndex, COL_PROJET).CellValue
        If strIDProjet = "" Then strIDProjet = "-1"
        dv.RowFilter = String.Format("[IDProjet] = '{0}'", strIDProjet)
        CType(cr.ListControlPart, GridDropDownGridListControlPart).DataSource = dv
        cc.ShowDropDown()
      End If
    Catch ex As Exception
      'Afficher dans event log.
    End Try
  End Sub

  Private Sub gridFavoris_CurrentCellShowingDropDown(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventArgs)

    Dim grid As GridControlBase = sender
    Dim cc As GridCurrentCell = grid.CurrentCell
    Dim cr As GridDropDownGridListControlCellRenderer = cc.Renderer
    Dim strIDProjet As String = _gridFavoris(cc.RowIndex, COL_PROJET).CellValue

    cr.ListControlPart.Grid.SetRowHidden(0, 0, True)
    e.Size = New Size(500, 600)

    If Not (IsDBNull(cr)) Then
      cr.ListControlPart.Grid.SetColHidden(0, 10, False)
      cr.ListControlPart.AutoSizeColumns = True

      If cc.ColIndex = COL_PROJET Then
        cr.ListControlPart.Grid.SetColHidden(1, 1, True)
        cr.ListControlPart.Grid.SetColHidden(4, 5, True)
        e.Size = New Size(302, 600)
        CType(cr.ListControlPart, GridDropDownGridListControlPart).DropDownRows = 10
        cr.ListControlPart.Grid.HScrollBehavior = GridScrollbarMode.Disabled
      End If

      If cc.ColIndex = COL_TACHE Then
        If strIDProjet = "" Then
          e.Cancel = True
          Exit Sub
        End If

        If Not (cr Is Nothing) Then
          cr.ListControlPart.Grid.SetColHidden(1, 2, True)
          cr.ListControlPart.Grid.SetColHidden(4, 5, True)
          cr.ListControlPart.Grid.SetColHidden(7, 10, True)

          e.Size = New Size(402, 600)
          cr.ListControlPart.Grid.HScrollBehavior = GridScrollbarMode.Disabled
          Dim dv As New DataView(dtTaches)

          'On filtre les tches sur IDProjet = projet slectionn dans la colonne des projet sur la mme ligne
          dv.RowFilter = String.Format("[IDProjet] = '{0}'", strIDProjet)
          CType(cr.ListControlPart, GridDropDownGridListControlPart).DataSource = dv
          CType(cr.ListControlPart, GridDropDownGridListControlPart).DropDownRows = 10

        End If
      End If

    End If
  End Sub

  'Retourne le titre du projet intIDProjet
  Public Function TrouverTitreProjet(ByVal intIdProjet As Integer) As String
    Dim dv As New DataView(dtProjets)
    dv.RowFilter = String.Format("[IDProjet] = '{0}'", intIdProjet)
    If dv.Count < 1 Then
      Return ("Erreur! Titre du projet introuvable!")
    Else
      Return dv.Item(0).Item("TitreProjet")
    End If
    dv = Nothing
  End Function 'TrouverTitreProjet

  'Retourne le titre de la tche intID
  Public Function TrouverNomTache(ByVal intId) As String
    Dim dv As New DataView(dtTaches)
    dv.RowFilter = String.Format("[ID] = '{0}'", intId)
    If dv.Count < 1 Then
      Return ("Erreur! Nom de la tche introuvable!")
    Else
      Return dv.Item(0).Item("NomTache")
    End If
    dv = Nothing
  End Function 'TrouverNomTache

End Class
